/*******************************************************************************
 * FoxGameObject_SpawnPoint generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxGameObject_SpawnPoint extends FoxGameObject
    placeable
    hidecategories(Navigation,Collision,Physics,Debug)
    autoexpandcategories(FoxGameObject_SpawnPoint);

var() class<FoxGameObject> ObjectToSpawn;
var() bool bSpawnInitial;
var() bool bDropOntoSpawn;
var() float SpawnInterval;
var() int MaxSpawnedObjectsAlive;
var() int MinSpawnedObjectsAlive;
var() ParticleSystem SpawnParticleSystem;
var transient array<FoxGameObject> SpawnedObjects;
var() float TriggeredRespawnDelay;
var() float DropOffset;

event PostBeginPlay()
{
    super.PostBeginPlay();
    // End:0x56
    if(bEnabled)
    {
        // End:0x2E
        if(bSpawnInitial)
        {
            SpawnObject();
        }
        // End:0x56
        if(SpawnInterval > float(0))
        {
            SetTimer(SpawnInterval, true, 'SpawnObject');
        }
    }
    //return;    
}

function SpawnObject()
{
    local FoxGameObject NewObject;

    // End:0x192
    if(ShouldSpawnObject())
    {
        // End:0x7C
        if(bDropOntoSpawn)
        {
            NewObject = Spawn(ObjectToSpawn, self,, Location + (vect(0.0, 0.0, 1.0) * DropOffset),,, true);
            NewObject.SetPhysics(2);
        }
        // End:0xA7
        else
        {
            NewObject = Spawn(ObjectToSpawn, self,, Location,,, true);
        }
        // End:0xE0
        if(SpawningRadius > float(0))
        {
            NewObject.SpawningRadius = SpawningRadius;
        }
        // End:0x192
        if(NewObject != none)
        {
            SpawnedObjects.AddItem(NewObject);
            // End:0x192
            if((WorldInfo.MyEmitterPool != none) && SpawnParticleSystem != none)
            {
                WorldInfo.MyEmitterPool.SpawnEmitter(SpawnParticleSystem, self.Location);
            }
        }
    }
    //return;    
}

function bool ShouldSpawnObject()
{
    return ((bEnabled == true) && ObjectToSpawn != none) && SpawnedObjects.Length < MaxSpawnedObjectsAlive;
    //return ReturnValue;    
}

function ObjectDestroyed(FoxGameObject DestroyedObject)
{
    SpawnedObjects.RemoveItem(DestroyedObject);
    // End:0x45
    if(SpawnedObjects.Length < MinSpawnedObjectsAlive)
    {
        SetTimer(TriggeredRespawnDelay, false, 'SpawnObject');
    }
    //return;    
}

defaultproperties
{
    bSpawnInitial=true
    MaxSpawnedObjectsAlive=1
    TriggeredRespawnDelay=1.0
    DropOffset=64.0
    begin object name=DrawSphere2 class=DrawSphereComponent
        SphereRadius=0.0
        SphereSides=50
        ReplacementPrimitive=none
    object end
    // Reference: DrawSphereComponent'Default__FoxGameObject_SpawnPoint.DrawSphere2'
    DrawSpawningRadius=DrawSphere2
    Components(0)=none
    begin object name=DrawSphere2 class=DrawSphereComponent
        SphereRadius=0.0
        SphereSides=50
        ReplacementPrimitive=none
    object end
    // Reference: DrawSphereComponent'Default__FoxGameObject_SpawnPoint.DrawSphere2'
    Components(1)=DrawSphere2
    RemoteRole=ENetRole.ROLE_None
}